<?php

namespace seraph_accel;

if( !defined( 'ABSPATH' ) )
	exit;

require_once( __DIR__ . '/Cmn/Gen.php' );
require_once( __DIR__ . '/Cmn/Ui.php' );
require_once( __DIR__ . '/Cmn/Fs.php' );
require_once( __DIR__ . '/Cmn/Db.php' );
require_once( __DIR__ . '/Cmn/Img.php' );
require_once( __DIR__ . '/Cmn/Plugin.php' );

const PLUGIN_SETT_VER								= 43;
const PLUGIN_DATA_VER								= 1;
const PLUGIN_EULA_VER								= 1;
const QUEUE_DB_VER									= 3;
const PLUGIN_STAT_VER								= 1;

function OnOptRead_Sett( $sett, $verFrom )
{
	if( $verFrom == 5 )
	{
		$verFrom = 6;

		if( Gen::GetArrField( $sett, array( 'cache', 'updPostDeps' ), array() ) === array( '/' ) )
			unset( $sett[ 'cache' ][ 'updPostDeps' ] );
	}

	if( $verFrom == 7 )
	{
		$verFrom = 8;

		if( Gen::GetArrField( $sett, array( 'cache', 'lazyInvTmp' ), false ) )
			Gen::SetArrField( $sett, array( 'cache', 'lazyInvForcedTmp' ), true );
	}

	if( $verFrom && $verFrom < 9 )
		Gen::SetArrField( $sett, array( 'contPr', 'css', 'groupFont' ), Gen::GetArrField( $sett, array( 'contPr', 'css', 'groupNonCrit' ), false ) );

	if( $verFrom && $verFrom < 10 )
	{
		Gen::SetArrField( $sett, array( 'contPr', 'normUrl' ), true );
		Gen::SetArrField( $sett, array( 'contPr', 'normUrlMode' ), 2 );
	}

	if( $verFrom && $verFrom < 11 )
		Gen::SetArrField( $sett, array( 'contPr', 'lazy', 'bjs' ), false );

	if( $verFrom && $verFrom < 12 )
		Gen::SetArrField( $sett, array( 'contPr', 'css', 'sepImp' ), false );

	if( $verFrom && $verFrom < 17 )
		Gen::SetArrField( $sett, array( 'cache', 'updPostOp' ), 0 );

	if( $verFrom && $verFrom < 20 )
		Gen::SetArrField( $sett, array( 'contPr', 'frm', 'lazy', 'elmntrBg' ), false );

	if( $verFrom && $verFrom < 21 )
	{
		Gen::SetArrField( $sett, array( 'cache', 'updPostDeps' ), Op_DepItems_MigrateFromOld( Gen::GetArrField( $sett, array( 'cache', 'updPostDeps' ), array() ) ) );
		Gen::SetArrField( $sett, array( 'cache', 'updAllDeps' ), Op_DepItems_MigrateFromOld( Gen::GetArrField( $sett, array( 'cache', 'updAllDeps' ), array() ) ) );
	}

	if( $verFrom && $verFrom < 22 )
		Gen::SetArrField( $sett, array( 'contPr', 'frm', 'lazy', 'youTubeFeed' ), false );

	if( $verFrom && $verFrom < 24 )
		Gen::SetArrField( $sett, array( 'contPr', 'img', 'szAdaptBg' ), false );

	if( $verFrom && $verFrom < 26 )
		Gen::SetArrField( $sett, array( 'cache', 'chunks', 'js' ), false );

	if( $verFrom && $verFrom < 27 )
	{
		Gen::SetArrField( $sett, array( 'contPr', 'img', 'webp', 'redir' ), Gen::GetArrField( $sett, array( 'contPr', 'img', 'redirWebp' ) ) );
		unset( $sett[ 'contPr' ][ 'img' ][ 'redirWebp' ] );

		Gen::SetArrField( $sett, array( 'contPr', 'img', 'webp', 'enable' ), false );
		Gen::SetArrField( $sett, array( 'contPr', 'img', 'avif', 'enable' ), false );
		Gen::SetArrField( $sett, array( 'contPr', 'img', 'avif', 'redir' ), false );
	}

	if( $verFrom && $verFrom < 28 )
		Gen::SetArrField( $sett, array( 'contPr', 'img', 'lazy', 'del3rd' ), false );

	if( $verFrom && $verFrom < 29 )
	{
		Gen::SetArrField( $sett, array( 'contPr', 'cp', 'sldBdt' ), false );
		Gen::SetArrField( $sett, array( 'contPr', 'cp', 'elmntrBgSldshw' ), false );
		Gen::SetArrField( $sett, array( 'contPr', 'css', 'corrErr' ), true );
	}

	if( $verFrom && $verFrom < 30 )
		Gen::SetArrField( $sett, array( 'contPr', 'cp', 'prtThSkel' ), false );

	if( $verFrom && $verFrom < 31 )
		Gen::SetArrField( $sett, array( 'contPr', 'img', 'lazy', 'smoothAppear' ), true );

	if( $verFrom && $verFrom < 32 )
		Gen::SetArrField( $sett, array( 'contPr', 'cp', 'fltsmThBgFill' ), false );

	if( $verFrom && $verFrom < 33 )
		Gen::SetArrField( $sett, array( 'contPr', 'grps', 'items' ), array() );

	if( $verFrom && $verFrom < 34 )
	{
		$grps = Gen::GetArrField( $sett, array( 'contPr', 'grps', 'items' ), array() );
		$grps[ '@' ] = Gen::GetArrField( OnOptGetDef_Sett(), array( 'contPr', 'grps', 'items', '@' ), array() );
		Gen::SetArrField( $grps, array( '@', 'enable' ), 0 );

		Gen::SetArrField( $sett, array( 'contPr', 'grps', 'items' ), $grps );
		Gen::SetArrField( $sett, array( 'contPr', 'cp', 'ukSldshw' ), false );
	}

	if( $verFrom && $verFrom < 35 )
	{
		Gen::SetArrField( $sett, array( 'contPr', 'cp', 'sldN2Ss' ), false );

		if( $verFrom >= 34 )
		{
			$grpDef = Gen::GetArrField( OnOptGetDef_Sett(), array( 'contPr', 'grps', 'items', '@' ), array() );
			foreach( Gen::GetArrField( $sett, array( 'contPr', 'grps', 'items' ), array() ) as $grpId => $grp )
			{
				Gen::SetArrField( $sett, array( 'contPr', 'grps', 'items', $grpId, 'sklExcl', '+' ), Gen::GetArrField( $grpDef, array( 'sklExcl', 0 ) ) );
				Gen::SetArrField( $sett, array( 'contPr', 'grps', 'items', $grpId, 'sklExcl', '+' ), Gen::GetArrField( $grpDef, array( 'sklExcl', 1 ) ) );
			}
		}
	}

	if( $verFrom && $verFrom < 36 )
		Gen::SetArrField( $sett, array( 'cache', 'srvClr' ), false );

	if( $verFrom && $verFrom < 37 )
	{
		Gen::SetArrField( $sett, array( 'contPr', 'cp', 'swBdt' ), false );
		Gen::SetArrField( $sett, array( 'contPr', 'cp', 'tdThumbCss' ), false );
	}

	if( $verFrom && $verFrom < 38 )
	{
		Gen::SetArrField( $sett, array( 'contPr', 'cp', 'elmsKitImgCmp' ), false );
		Gen::SetArrField( $sett, array( 'contPr', 'cp', 'haCrsl' ), false );
	}

	if( $verFrom && $verFrom < 39 )
	{
		Gen::SetArrField( $sett, array( 'contPr', 'cp', 'elmntrTabs' ), false );
	}

	if( $verFrom && $verFrom < 40 )
	{
		Gen::SetArrField( $sett, array( 'contPr', 'cp', 'phtncThmb' ), true );
	}

	if( $verFrom && $verFrom < 42 )
	{
		Gen::SetArrField( $sett, array( 'contPr', 'normalize' ), Gen::GetArrField( $sett, array( 'contPr', 'normalize' ), 0 ) | 512 );
	}

	if( $verFrom && $verFrom < 43 )
	{
		Gen::SetArrField( $sett, array( 'contPr', 'cp', 'elmntrVids' ), false );
	}

	return( $sett );
}

function Op_DepItems_MigrateFromOld( $dependItems )
{
	foreach( $dependItems as &$dependItem )
	{
		$dependItem = preg_replace( '`(^|\\W)IF:([^:]+):([^:]+)`',							'${1}@IF@${2}@${3}',					$dependItem );
		$dependItem = preg_replace( '`(^|\\W)terms:`',										'${1}@terms@',							$dependItem );
		$dependItem = preg_replace( '`(^|\\W)termsOfClass:([^:]+):([^:]+):([^:]+)`',		'${1}@termsOfClass@${2}@${3}@${4}',		$dependItem );
		$dependItem = preg_replace( '`(^|\\W)home($|\\W)`',									'${1}@home${2}',						$dependItem );
		$dependItem = preg_replace( '`(^|\\W)postsBase:`',									'${1}@postsBase@',						$dependItem );
		$dependItem = preg_replace( '`(^|\\W)posts:`',										'${1}@posts@',							$dependItem );
		$dependItem = preg_replace( '`(^|\\W)sitemapItems:`',								'${1}@sitemapItems@',					$dependItem );
	}

	return( $dependItems );
}

function OnFileValuesGetRootDir()
{
	return( array( GetCacheDir() . '/s', GetSiteId() ) );
}

function OnAsyncTasksGetFile()
{
	return( GetCacheDir() . '/at' );
}

function OnOptGetDef_Sett()
{
	return( array(

		'cache' => array(
			'enable' => true,

			'srvClr' => false,
			'cron' => true,

			'lazyInv' => true,
			'lazyInvForcedTmp' => false,
			'lazyInvTmp' => false,

			'updPost' => true,
			'updPostOp' => 0,
			'updPostDeps' => array(
				'@home',
				'@pageNums',
				'@postsBase@{post_type}:<|@pageNums>',
				'@termsOfClass@categories@{post_type}@{ID}:<|@pageNums>',
			),
			'updPostMeta' => false,
			'updPostMetaExcl' => array(
				'@^\\d+$@',
				'@^_edit_lock$@',
				'@^classic-editor-remember$@',
				'@post_views_@',
				'@^import_started_at@',
			),

			'updTerms' => false,
			'updTermsOp' => 2,
			'updTermsDeps' => array( 'category', 'product_cat', 'course_cat' ),

			'updAllDeps' => array(
				'@home',
				'@sitemapItems@/sitemap.xml:<|@pageNums>',
			),

			'updSche' => array(
				'def' => array(
					'enable' => false,
					'op' => 0,
					'period' => 24,
					'periodN' => 1,
					'times' => array(
						array(
							'm' => 0,
							'tm' => 0,
						)
					),
					'deps' => array(
						'@home',
					),
				),
			),

			'maxProc' => 1,
			'procInterval' => 5,
			'procMemLim' => 2048,

			'autoProc' => true,

			'timeout' => 12 * 60,
			'timeoutCln' => 182 * 24 * 60,
			'ctxTimeoutCln' => 15 * 24 * 60,
			'autoClnPeriod' => 24 * 60,

			'encs' => array( '', 'gzip', 'deflate', 'compress' ),
			'dataCompr' => array( 'deflate' ),

			'chunks' => array(
				'enable' => true,
				'js' => true,
				'css' => false,
				'seps' => array(

				),
			),

			'urisExcl' => array(),
			'exclAgents' => array(
			),
			'exclCookies' => array(),
			'exclArgsAll' => true,

			'exclArgs' => array(
				'aiosp_sitemap_path',
				'aiosp_sitemap_page',
				'xml_sitemap',
				'seopress_sitemap',
				'seopress_news',
				'seopress_video',
				'seopress_cpt',
				'seopress_paged',
				'sitemap',
				'sitemap_n',
			),

			'skipArgsAll' => false,
			'skipArgs' => array( 'redirect_to', 'utm_source', 'utm_medium', 'utm_campaign', 'utm_content', 'utm_term', 'fbclid', 'gclid', '_ga', 'yclid' ),

			'hdrs' => array(
				'@^Set-Cookie\\s*:\\s*wordpress_test_cookie\\s*=@i',
				'@^X-XSS-Protection\\s*:@i',
				'@^X-Frame-Options\\s*:@i',
				'@^Content-Security-Policy\\s*:@i',
				'@^Referrer-Policy\\s*:@i',
				'@^Feature-Policy\\s*:@i',
				'@^Permissions-Policy\\s*:@i',
			),

			'views' => true,
			'viewsDeviceGrps' => array(
				array(
					'enable' => false,
					'name' => '',
					'id' => 'mobilehighres',
					'agents' => array( 'android', 'bada', 'incognito', 'kindle', 'maemo', 'mobi', 'opera mini', 's8000', 'series60', 'ucbrowser', 'ucweb', 'webmate', 'webos', ),
				),

				array(
					'enable' => false,
					'name' => '',
					'id' => 'mobilelowres',
					'agents' => array( '240x320', '2.0 mmp', '\bppc\b', 'alcatel', 'amoi', 'asus', 'au-mic', 'audiovox', 'avantgo', 'benq', 'bird', 'blackberry', 'blazer', 'cdm', 'cellphone', 'danger', 'ddipocket', 'docomo', 'dopod', 'elaine/3.0', 'ericsson', 'eudoraweb', 'fly', 'haier', 'hiptop', 'hp.ipaq', 'htc', 'huawei', 'i-mobile', 'iemobile', 'iemobile/7', 'iemobile/9', 'j-phone', 'kddi', 'konka', 'kwc', 'kyocera/wx310k', 'lenovo', 'lg', 'lg/u990', 'lge vx', 'midp', 'midp-2.0', 'mmef20', 'mmp', 'mobilephone', 'mot-v', 'motorola', 'msie 10.0', 'netfront', 'newgen', 'newt', 'nintendo ds', 'nintendo wii', 'nitro', 'nokia', 'novarra', 'o2', 'openweb', 'opera mobi', 'opera.mobi', 'p160u', 'palm', 'panasonic', 'pantech', 'pdxgw', 'pg', 'philips', 'phone', 'playbook', 'playstation portable', 'portalmmm', 'proxinet', 'psp', 'qtek', 'sagem', 'samsung', 'sanyo', 'sch', 'sch-i800', 'sec', 'sendo', 'sgh', 'sharp', 'sharp-tq-gx10', 'small', 'smartphone', 'softbank', 'sonyericsson', 'sph', 'symbian', 'symbian os', 'symbianos', 'toshiba', 'treo', 'ts21i-10', 'up.browser', 'up.link', 'uts', 'vertu', 'vodafone', 'wap', 'willcome', 'windows ce', 'windows.ce', 'winwap', 'xda', 'xoom', 'zte', ),
				),

				array(
					'enable' => true,
					'name' => '',
					'id' => 'mobile',
					'agents' => array( 'mobile', 'android', 'silk/', 'kindle', 'blackberry', 'opera mini', 'opera mobi', ),
				),
			),
			'viewsGrps' => array(
				array(
					'enable' => true,
					'name' => 'AMP',
					'cookies' => array(),
					'args' => array( 'amp', ),
				),

				array(
					'enable' => true,
					'name' => 'WPML',
					'cookies' => array( 'wp_wcml_currency', 'wcml_client_currency', ),
					'args' => array( 'lang', ),
				),

				array(
					'enable' => true,
					'name' => 'WPtouch',
					'cookies' => array( 'wptouch-pro-cache-state', 'wptouch-pro-view', ),
					'args' => array(),
				),

				array(
					'enable' => true,
					'name' => 'VillaTheme WooCommerce Multi Currency',
					'cookies' => array( 'wmc_current_currency' ),
				),
			),

			'ctx' => false,
			'ctxSessSep' => true,
			'ctxCliRefresh' => true,
			'ctxGrps' => array(
				'common' => array(
					'enable' => true,
					'name' => 'Common',
					'cookies' => array(
						'wp-postpass_',
						'comment_author_',
						'sc_commented_posts',
					),
					'args' => array(
						'key',
					),

					'tables' => array(

					),
				),

				'wordpress-social-login' => array(
					'enable' => true,
					'name' => 'Social Login',
					'args' => array(
						'action',
					),
				),

				'theme_woodmart' => array(
					'enable' => true,
					'name' => 'WoodMart Theme',
					'cookies' => array(
						'woodmart_wishlist_products',
					),
				),

				'jet-cw' => array(
					'enable' => true,
					'name' => 'Jet',
					'cookies' => array(
						'jet-wish-list',
						'jet-compare-list',
					),
				),

				'woocommerce' => array(
					'enable' => true,
					'name' => 'WooCommerce',
					'cookies' => array(
						'woocommerce_cart_hash',
						'wp_woocommerce_session_',
						'yith_wcwl_session_',
					),

					'args' => array(
						'add-to-cart',
						'remove_item',
						'removed_item',
						'undo_item',
						'update_cart',
						'proceed',
						'order_again',
						'apply_coupon',
						'remove_coupon',
					),

					'tables' => array(

					),
				),

				'lifterlms' => array(
					'enable' => true,
					'name' => 'LMS by LifterLMS',

					'tables' => array(

					),
				),
			),
		),

		'cacheBr' => array(
			'enable' => true,
			'timeout' => 30 * 24 * 60,
		),

		'contPr' => array(
			'enable' => true,
			'normalize' => 1|2,

			'normUrl' => false,
			'normUrlMode' => 2,

			'min' => true,
			'minCmtsExcl' => array(
				'@^\\s*/?noindex\\s*$@i',
				'@\\[et-ajax\\]@i',
			),

			'lazy' => array(
				'items' => array(
				),
				'bjs' => true
			),

			'earlyPaint' => true,

			'img' => array(
				'srcAddLm' => false,
				'sysFlt' => false,
				'inlSml' => true,
				'inlSmlSize' => 1024,
				'webp' => array(
					'enable' => true,
					'redir' => true,
				),
				'avif' => array(
					'enable' => false,
					'redir' => true,
				),
				'szAdaptBg' => true,
				'szAdaptExcl' => array(

				),
				'szAdaptBgCxMin' => 768,
				'lazy' => array(
					'setSize' => false,
					'load' => true,
					'smoothAppear' => true,
					'del3rd' => true,
					'excl' => array(

					),
				),

				'cacheExt' => array(
					'@\\.cdninstagram\\.com/@',
					'@\\.googleusercontent\\.com/@',
				),
			),

			'frm' => array(
				'lazy' => array(
					'enable' => true,
					'yt' => true,
					'vm' => true,
					'elmntrBg' => true,
					'youTubeFeed' => true,

				),
			),

			'cp' => array(
				'sldBdt' => true,
				'swBdt' => true,
				'elmntrBgSldshw' => true,
				'elmntrVids' => true,
				'prtThSkel' => true,
				'fltsmThBgFill' => true,
				'ukSldshw' => true,
				'sldN2Ss' => true,
				'tdThumbCss' => true,
				'elmsKitImgCmp' => true,
				'haCrsl' => true,
				'elmntrTabs' => true,
				'phtncThmb' => true,
			),

			'js' => array(

				'groupNonCrit' => false,
				'min' => false,
				'minExcls' => array(
				),
				'other' => array(
					'incl' => array(

					),
				),
				'cprRem' => false,
				'optLoad' => true,
				'cplxDelay' => false,
				'preLoadEarly' => false,
				'loadFast' => false,
				'clickDelay' => 250,

				'nonCrit' => array(
					'inl' => true,
					'int' => true,
					'ext' => true,
					'excl' => true,
					'items' => array(

						'body:@\\Wfunction\\s+et_core_page_resource_fallback\\W@',

						'body:@\\WTRINITY_TTS_WP_CONFIG\\W@',
					),

					'timeout' => array(
						'enable' => true,
						'v' => 4500,
					),
				),
				'spec' => array(
					'timeout' => array(
						'enable' => false,
						'v' => 500,
					),
					'items' => array(

					),
				),
				'skips' => array(),
			),

			'css' => array(
				'corrErr' => true,
				'group' => false,
				'groupCombine' => true,
				'groupNonCrit' => false,
				'groupNonCritCombine' => true,
				'groupFont' => true,
				'groupFontCombine' => true,
				'sepImp' => true,
				'min' => true,
				'optLoad' => true,
				'inlAsSrc' => false,
				'inlCrit' => true,
				'inlNonCrit' => false,
				'delayNonCritWithJs' => true,
				'nonCrit' => array(
					'auto' => true,
					'autoExcls' => array(),
					'inl' => true,
					'int' => true,
					'ext' => true,
					'excl' => false,
					'items' => array(),
				),
				'fontOptLoad' => true,
				'fontOptLoadDisp' => 'swap',
				'fontCrit' => false,

				'skips' => array(
					'id:@^reycore-critical-css$@',
				),

				'custom' => array(
					'0' => array( 'enable' => true, 'data' => '' ),
					'jet-menu'		=> array( 'enable' => false,	'descr' => 'Jet Menu',					'data' => ".seraph-accel-js-lzl-ing ul.jet-menu > li[id^=jet-menu-item-] {\n\tdisplay: none!important;\n}" ),
					'xo-slider'		=> array( 'enable' => true,		'descr' => 'XO Slider',					'data' => ".xo-slider .slide-content {\n\tdisplay: unset!important;\n}" ),
					'owl-carousel'	=> array( 'enable' => true,		'descr' => 'OWL Carousel',				'data' => ".seraph-accel-js-lzl-ing .owl-carousel {\n\tdisplay:block!important;\n}\n\n.seraph-accel-js-lzl-ing .owl-carousel > .item:not(:first-child) {\n\tdisplay:none;\n}" ),
					'ult-carousel'	=> array( 'enable' => true,		'descr' => 'Ultimate Carousel',			'data' => ".seraph-accel-js-lzl-ing .ult-carousel-wrapper {\n\tvisibility:initial!important;\n}\n\n.seraph-accel-js-lzl-ing .ult-carousel-wrapper .ult-item-wrap:not(:first-child) {\n\tdisplay:none;\n}" ),
					'bdt-slideshow'	=> array( 'enable' => true,		'descr' => 'Airtech Plumber Slider',	'data' => ".seraph-accel-js-lzl-ing .bdt-prime-slider-previous,.seraph-accel-js-lzl-ing .bdt-prime-slider-next {\n\tdisplay: none!important;\n}" ),
					'n2-ss-slider'	=> array( 'enable' => true,		'descr' => 'Smart Slider',				'data' => "ss3-force-full-width {\n\twidth: var(--seraph-accel-client-width)!important;\n\ttransform:none!important;\n\topacity: 1!important;\n\tmargin-left: calc((100% - var(--seraph-accel-client-width)) / 2);\n}\n\n.n2-ss-slider:not(.n2-ss-loaded) .n2-ss-slide-backgrounds [data-public-id=\"1\"],\n.n2-ss-slider:not(.n2-ss-loaded) [data-slide-public-id=\"1\"] {\n\ttransform: translate3d(0px, 0px, 0px)!important;\n}\n\n.n2-ss-slider:not(.n2-ss-loaded) .n2-ss-slide:not([data-slide-public-id=\"1\"]),\n.n2-ss-slider:not(.n2-ss-loaded) .n2-ss-layer.js-lzl-n-ing,\n.n2-ss-slider:not(.n2-ss-loaded):not([style*=ss-responsive-scale]) [data-responsiveposition],\n.n2-ss-slider:not(.n2-ss-loaded):not([style*=ss-responsive-scale]) [data-responsivesize],\n.n2-ss-slider.n2-ss-loaded .n2-ss-layer.js-lzl-ing {\n\tvisibility: hidden!important;\n}\n\n.n2-ss-slider:not(.n2-ss-loaded) [data-slide-public-id=\"1\"] .n2-ss-layers-container {\n\topacity: 1!important;\n}\n\n.n2-ss-slider-pane\n{\n\topacity: 1!important;\n\tanimation-name: none!important;\n\t--self-side-margin: auto!important;\n\t--slide-width: 100%!important;\n}" ),
					'wp-block-ultimate-post-slider'	=> array( 'enable' => true,		'descr' => 'Block Ultimate Post Slider',	'data' => "[class*=wp-block-ultimate-post-post-slider] .ultp-block-items-wrap:not(.slick-initialized) > .ultp-block-item:not(:first-child)\n{\n\tdisplay: none!important;\n}" ),
					'preloaders'	=> array( 'enable' => true,		'descr' => 'Preloaders',				'data' => "#preloader,#loader-wrapper,#royal_preloader,#loftloader-wrapper,.rokka-loader,.page-preloader-cover {\n\tdisplay:none!important;\n}\n\nbody.royal_preloader{\n\tvisibility:hidden!important;\n}" ),
					'elementor'		=> array( 'enable' => true,		'descr' => 'Elementor',					'data' => ".elementor-invisible {\n\tvisibility: visible!important;\n}\n\n.vc_row[data-vc-full-width-init=\"false\"] {\n\tposition: relative;\n\twidth: var(--seraph-accel-client-width);\n\tleft: calc((100% - var(--seraph-accel-client-width)) / 2);\n}\n\n.elementor-top-section.elementor-section-stretched[data-settings*=\"section-stretched\"] {\n\twidth: var(--seraph-accel-client-width)!important;\n\tleft: calc((100% - var(--seraph-accel-client-width)) / 2)!important;\n}\n\n.elementor-element[data-settings*=\"animation\\\"\"] {\n\tanimation-name: none!important;\n}" ),
					'tag-div'		=> array( 'enable' => true,		'descr' => 'tagDiv',					'data' => "body.td-animation-stack-type0 .td-animation-stack .entry-thumb,\nbody.td-animation-stack-type0 .post img:not(.woocommerce-product-gallery img):not(.rs-pzimg),\nbody.td-animation-stack-type0 .td-animation-stack .td-lazy-img,\n.tdb_header_menu .tdb-menu-items-pulldown.tdb-menu-items-pulldown-inactive {\n\topacity: 1!important;\n}" ),
					'photonic-thumb'	=> array( 'enable' => true,		'descr' => 'Photonic Photo Gallery',	'data' => ".photonic-thumb,\r\n.photonic-thumb a img {\r\n\tdisplay: unset !important;\r\n}\r\n\r\n.photonic-loading {\r\n\tdisplay: none !important;\r\n}\r\n\r\n.photonic-stream * {\r\n\tanimation-name: none !important;\r\n}" ),
					'avia-slideshow'	=> array( 'enable' => true,		'descr' => 'Avia Slideshow',		'data' => ".avia-slideshow.av-default-height-applied .avia-slideshow-inner > li:first-child {\r\n\topacity: 1 !important;\r\n\tvisibility: visible !important;\r\n}\r\n" ),
				),
			),

			'cdn' => array(

				'items' => array(
					array(
						'enable' => true,
						'addr' => '',
						'types' => array( 'js', 'css', 'less', 'gif', 'jpeg', 'jpg', 'bmp', 'png', 'svg', 'eot', 'aac', 'mp3', 'mp4', 'ogg', 'pdf', 'docx', 'otf', 'ttf', 'woff' ),
						'uris' => array( 'wp-content', 'wp-includes' ),
						'urisExcl' => array(),
					),
				),
			),

			'grps' => array(

				'items' => array(

					'@' => array(
						'enable' => 2,
						'name' => 'Common',
						'urisIncl' => array(),
						'patterns' => array(),
						'views' => array(),
						'sklExcl' => array(
							'matchAll(.//*[@class]/@class, "@(?:post|page|postid|pageid|-id|image|term|item|avatar|user|link_wishlist)[\\-_]([\\da-f]+)@i")',
							'matchAll(.//*[@id]/@id, "@[\\-_]([\\da-f]+)@i")',

							'.//svg[@width="0"][@height="0"]',

							'.//body[contains(concat(" ",normalize-space(@class)," ")," woocommerce ")][contains(concat(" ",normalize-space(@class)," ")," single-product ")]//*[match(concat(" ",normalize-space(@class)," "),"@[\\s\\-]products\\s@")]/*',
							'matchAll(.//*[contains(concat(" ",normalize-space(@class)," ")," woocommerce ")]//*[contains(concat(" ",normalize-space(@class)," ")," product ")]/@class, "@\\sproduct_cat-[^\\s]+@", "@\\sproduct_tag-[^\\s]+@", "@\\spa_[^\\s]+@")',
							'matchAll(.//*[contains(concat(" ",normalize-space(@class)," ")," woocommerce-product-attributes-item ")]/@class, "@\\swoocommerce-product-attributes-item--attribute_[^\\s]+@")',
							'matchAll(.//*[contains(concat(" ",normalize-space(@class)," ")," woocommerce ")]//*[contains(concat(" ",normalize-space(@class)," ")," comment-author-")]/@class, "@\\scomment-author-[^\\s]+@")',

						),
					),

				),
			),
		),

		'test' => array(
			'contDelay' => false,
			'contDelayTimeout' => 5000,
			'contExtra' => false,
			'contExtraSize' => 0x80000,
		),

		'hdrTrace' => false,
		'debugInfo' => false,
		'debug' => false,
		'emojiIcons' => false,
	) );
}

function GetSiteId( $site = null )
{
	if( !is_multisite() )
		return( 'm' );

	if( !$site )
	{
		$site = get_current_site();
		$site = new AnyObj( array( 'blog_id' => get_current_blog_id(), 'site_id' => $site -> site_id ) );
	}

	if( defined( 'SITE_ID_CURRENT_SITE' ) && defined( 'BLOG_ID_CURRENT_SITE' ) && $site -> blog_id == BLOG_ID_CURRENT_SITE && $site -> site_id == SITE_ID_CURRENT_SITE )
		return( 'm' );

	return( '' . $site -> site_id . '_' . $site -> blog_id );
}

function GetCacheDir()
{
	return( WP_CONTENT_DIR . '/cache/seraphinite-accelerator' );
}

function GetCacheDataDir( $siteCacheRootPath )
{
	return( $siteCacheRootPath . '/d' );
}

function GetCacheViewsDir( $siteCacheRootPath, $siteSubId = null )
{
	$siteCacheRootPath .= '/v';
	if( $siteSubId )
		$siteCacheRootPath .= '-' . $siteSubId;
	return( $siteCacheRootPath );
}

function _GetCacheCurUserSessionHash( $sessionId, $userSessionId, $userId, $expiration )
{
	return( hash_hmac( function_exists( 'hash' ) ? 'sha256' : 'sha1', $sessionId . $userSessionId . $userId . $expiration, AUTH_KEY ) );
}

function GetProcControlfileFullPath( $file )
{
	if( $file )
		$file = GetCacheDir() . '/pc/' . $file;
	return( $file );
}

function GetCacheCurUserSession( $siteId )
{
	global $seraph_accel_g_sessInfo;

	if( is_array( $seraph_accel_g_sessInfo ) )
		return( $seraph_accel_g_sessInfo );

	$sessInfoDef = array( 'userId' => '0' );

	$secure = is_ssl();
	$cookie = Gen::SanitizeTextData( (isset($_COOKIE[ ( $secure ? '__Secure-' : '' ) . 'wp_seraph_accel_sess_' . $siteId ])?$_COOKIE[ ( $secure ? '__Secure-' : '' ) . 'wp_seraph_accel_sess_' . $siteId ]:null) );
	if( empty( $cookie ) && $secure )
		$cookie = Gen::SanitizeTextData( (isset($_COOKIE[ 'wp_seraph_accel_sess_' . $siteId ])?$_COOKIE[ 'wp_seraph_accel_sess_' . $siteId ]:null) );
	if( empty( $cookie ) )
		return( $seraph_accel_g_sessInfo = $sessInfoDef );

	$cookie_elements = explode( '|', $cookie );
	if( count( $cookie_elements ) !== 5 )
		return( $seraph_accel_g_sessInfo = $sessInfoDef );

	list( $userSessionId, $sessionId, $userId, $expiration, $hmac ) = $cookie_elements;

	if( $expiration && time() > $expiration )
		return( $seraph_accel_g_sessInfo = $sessInfoDef );

	$hmacCheck = _GetCacheCurUserSessionHash( $sessionId, $userSessionId, $userId, $expiration );
	if( $hmac !== $hmacCheck )
		return( $seraph_accel_g_sessInfo = $sessInfoDef );

	return( $seraph_accel_g_sessInfo = array( 'sessId' => $sessionId, 'userSessId' => $userSessionId, 'userId' => $userId, 'expiration' => $expiration ) );
}

function ShouldCurUserSessionExist()
{
	foreach( $_COOKIE as $cookKey => $cookVal )
	{
		if( strpos( $cookKey, 'wordpress_logged_in_' ) === 0 )
			return( true );

	}

	return( false );
}

function SetCacheCurUserSession( $siteId, $sessionId, $userSessionId, $userId, $expiration )
{
	if( headers_sent() )
		return;

	global $seraph_accel_g_sessInfo;

	$hmac = _GetCacheCurUserSessionHash( $sessionId, $userSessionId, $userId, $expiration );
	$secure = is_ssl();
	Net::SetCookie( ( $secure ? '__Secure-' : '' ) . 'wp_seraph_accel_sess_' . $siteId, $userSessionId . '|' . $sessionId . '|' . $userId . '|' . $expiration . '|' . $hmac, array( 'expires' => Gen::GetCurRequestTime() + YEAR_IN_SECONDS, 'path' => COOKIEPATH, 'domain' => COOKIE_DOMAIN, 'secure' => $secure, 'httponly' => true, 'samesite' => 'Strict' ) );

	$seraph_accel_g_sessInfo = array( 'sessId' => $sessionId, 'userSessId' => $userSessionId, 'userId' => $userId, 'expiration' => $expiration );
}

function _GetDataFileComprExt( $compr, $composite = true )
{

	switch( $compr )
	{
	case 'deflate':
		return( $composite ? '.deflu' : '.gz' );

	case 'brotli':

		return( '.br' );
	}

	return( '' );
}

function _GetDataFileEncExt( $encoding, $composite = true )
{

	switch( $encoding )
	{
	case 'gzip':
	case 'deflate':
	case 'compress':
		return( $composite ? '.deflu' : '.gz' );

	case 'br':

		return( '.br' );
	}

	return( '' );
}

function GetCacheCos( $oiCi )
{
	return( @intval( Gen::GetFileExt( $oiCi ), 16 ) );
}

function _CacheCompDf( $data, $level = -1 )
{

	$ctx = deflate_init( ZLIB_ENCODING_RAW, array( 'level' => $level ) );
	if( $ctx === false )
		return( false );

	$data = deflate_add( $ctx, $data, ZLIB_FULL_FLUSH );
	if( $data === false )
		return( false );

	$blockLast = deflate_add( $ctx, '', ZLIB_FINISH );
	if( $blockLast !== "\x03\0" )
		return( false );

	return( $data );
}

function _CacheCompBr( $data, $level = 11 )
{

	$ctx = Gen::CallFunc( 'brotli_compress_init', array( $level, BROTLI_GENERIC ), false );
	if( !$ctx )
		return( false );

	$blockFirst = brotli_compress_add( $ctx, '', 1 );
	if( $blockFirst !== "\x6b\x00" )
		return( false );

	$data = brotli_compress_add( $ctx, $data, 1 );
	if( $data === false )
		return( false );

	$blockLast = brotli_compress_add( $ctx, '', BROTLI_FINISH );
	if( $blockLast !== "\x03" )
		return( false );

	return( $data );
}

function IsBrotliAvailable()
{
	return( function_exists( 'brotli_compress_init' ) );
}

function CacheCvs( $sz, $szOrig )
{
	return( $sz !== false && ( ( $sz === 0 && $szOrig === 0 ) || ( $sz !== 0 && $szOrig !== 0 ) ) );
}

function _IsSrvNotSupportGzAssets()
{

	return( preg_match( '@litespeed@i', (isset($_SERVER[ 'SERVER_SOFTWARE' ])?$_SERVER[ 'SERVER_SOFTWARE' ]:'') ) );
}

function CacheCw( $settCache, $siteRootPath, $dataPath, $composite, $content, $type, $fileExt = null )
{
	if( !$fileExt )
		$fileExt = $type;

	$oiCi = @md5( $content ) . '.' . sprintf( '%x', strlen( $content ) );

	$dataComprs = Gen::GetArrField( $settCache, array( 'dataCompr' ), array() );
	if( empty( $dataComprs ) )
		$dataComprs[] = '';

	if( $type != 'html' )
	{
		$dataPath .= '/' . $type;
		if( !$composite )
		{
			if( ( $type != 'css' && $type != 'js' ) || _IsSrvNotSupportGzAssets() )
				$dataComprs = array( '' );
			else if( !in_array( '', $dataComprs, true ) )
				$dataComprs[] = '';
		}
	}

	$writeOk = true;
	$writeFailDsc = null;

	foreach( $dataComprs as $dataCompr )
	{
		$dataFileExt = _GetDataFileComprExt( $dataCompr, $composite );
		if( $dataFileExt === null )
		{
			$writeOk = false;
			LastErrDsc_Set( 'Compression \'' . $dataCompr . '\' is not supported' );
			break;
		}

		$oiCf = $dataPath . '/' . $oiCi . '.' . $fileExt . $dataFileExt;

		if( CacheCvs( @filesize( $oiCf ), strlen( $content ) ) )
			continue;

		$oiCfTmp = $oiCf . '.tmp';
		Gen::FileOpenWithMakeDir( $chunkFileStm, $oiCfTmp, 'cb' );
		if( $chunkFileStm )
		{
			if( @flock( $chunkFileStm, LOCK_NB | LOCK_EX ) )
			{
				if( @ftruncate( $chunkFileStm, 0 ) )
				{
					$contentWrite = false;
					switch( $dataCompr )
					{
					case '':
						$contentWrite = $content;
						break;

					case 'deflate':
						$contentWrite = ( $dataFileExt == '.gz' ) ? @gzencode( $content, 9 ) : _CacheCompDf( $content, 9 );
						break;

					case 'brotli':
						$contentWrite = ( $dataFileExt == '.br' ) ? Gen::CallFunc( 'brotli_compress', array( $content, 11 ), false ) : _CacheCompBr( $content, 11 );
						break;
					}

					if( $contentWrite === false || $contentWrite === null )
					{
						$writeOk = false;
						LastErrDsc_Set( 'Can\'t compress data via \'' . $dataCompr . '\'' );
					}
					else if( @fwrite( $chunkFileStm, $contentWrite ) === false )
					{
						$writeOk = false;
						LastErrDsc_Set( 'Can\'t write to file \'' . $oiCfTmp . '\'' );
					}

					unset( $contentWrite );
				}
				else
				{
					$writeOk = false;
					LastErrDsc_Set( 'Can\'t truncate file \'' . $oiCfTmp . '\'' );
				}

				@fclose( $chunkFileStm );

				if( $writeOk && !@rename( $oiCfTmp, $oiCf ) )
				{
					$writeOk = false;
					LastErrDsc_Set( 'Can\'t rename file \'' . $oiCfTmp . '\' to \'' . $oiCf . '\'' );
				}
			}
			else
				@fclose( $chunkFileStm );
		}
		else
		{
			$writeOk = false;
			LastErrDsc_Set( 'Can\'t open file \'' . $oiCfTmp . '\'' );
		}

		if( !$writeOk )
		{
			@unlink( $oiCfTmp );
			@unlink( $oiCf );
			break;
		}
	}

	if( !$writeOk )
		return( null );

	if( $siteRootPath !== null && strpos( $dataPath, $siteRootPath . '/' ) === 0 )
		$relFilePath = substr( $dataPath, strlen( $siteRootPath ) + 1 ) . '/';
	else
		$relFilePath = '';
	$relFilePath .= $oiCi . '.' . $fileExt;

	return( array( 'id' => $oiCi, 'relFilePath' => $relFilePath ) );
}

function _ContentCw( &$dsc, $data, $type, $settCache, $dataPath )
{
	if( !$data )
		return( true );

	$oiC = CacheCw( $settCache, null, $dataPath, true, $data, $type );
	if( !$oiC )
		return( false );

	$dsc[ 'p' ][] = $oiC[ 'id' ];
	return( true );
}

function CacheReadDsc( $filePath )
{
	return( @unserialize( @file_get_contents( $filePath ) ) );
}

function CacheDscUpdate( $settCache, $content, $deps, $subParts, $dataPath, $tmp = false, $origContHash = null, $learnId = null )
{
	global $seraph_accel_g_dscFile;
	global $seraph_accel_g_dscFilePending;

	$dsc = array( 'p' => array() );

	$writeOk = true;

		$writeOk = _ContentCw( $dsc, $content, 'html', $settCache, $dataPath );

	$dsc[ 'c' ] = pack( 'V', crc32( $content ) );
	$dsc[ 'a' ] = hash( 'adler32', $content, true );

	if( $deps )
		$dsc[ 's' ] = $deps;

	if( $writeOk )
	{
		$dscOld = CacheReadDsc( $seraph_accel_g_dscFile );

		if( $tmp && $dscOld && isset( $dscOld[ 'b' ] ) )
			$dsc[ 'b' ] = $dscOld[ 'b' ];

		{
			if( !$tmp && $dscOld && (isset($dscOld[ 't' ])?$dscOld[ 't' ]:null) )
				$hdrs = (isset($dscOld[ 'hd' ])?$dscOld[ 'hd' ]:null);
			else
				$hdrs = GetCurHdrsToStoreInCache( $settCache );

			if( $hdrs )
				$dsc[ 'hd' ] = $hdrs;
		}

		$dscFileNew = $seraph_accel_g_dscFile . '.new';

		if( @file_put_contents( $dscFileNew, @serialize( $dsc ) ) === false )
			$writeOk = false;

		if( $writeOk )
		{
			if( $tmp )
			{
				$preservedFileTime = @filemtime( $seraph_accel_g_dscFile );
				if( !@touch( $dscFileNew, $preservedFileTime ? $preservedFileTime : 10 ) )
					$writeOk = false;
			}

			if( $writeOk && !@rename( $dscFileNew, $seraph_accel_g_dscFile ) )
				$writeOk = false;
			else if( !$tmp && $dscOld && (isset($dscOld[ 't' ])?$dscOld[ 't' ]:null) )
				if( $oiCi = Gen::GetArrField( $dscOld, array( 'p', 0 ) ) )
					foreach( glob( $dataPath . '/' . $oiCi . '.html*', GLOB_NOSORT ) as $file )
						@unlink( $file );
		}

		if( !$writeOk )
			@unlink( $dscFileNew );
	}

	if( $tmp !== 'u' )
		$ulr = @unlink( $seraph_accel_g_dscFilePending );
	if( !$tmp && Gen::GetFileExt( $seraph_accel_g_dscFilePending ) == 'pp' )
		@unlink( substr( $seraph_accel_g_dscFilePending, 0, -1 ) );

	return( $writeOk ? $dsc : null );
}

function IsCronEnabled()
{
	return( !( defined( 'DISABLE_WP_CRON' ) && DISABLE_WP_CRON ) );
}

function CacheDoesCronDelayPageLoad()
{
	if( !IsCronEnabled() )
		return( false );
	if( Gen::IsRequestSessionsCanBeClosedForContinueBgWork() )
		return( false );
	return( true );
}

function CacheDoCronAndEndRequest()
{
	global $seraph_accel_g_prepPrms;

	if( $seraph_accel_g_prepPrms !== null || !IsCronEnabled() || !Gen::GetArrField( Plugin::SettGet(), array( 'cache', 'cron' ), false ) )
		return( null );

	if( !Gen::CloseCurRequestSessionForContinueBgWork() )
		return( false );

	add_action( 'wp_loaded', function() { if( Wp::GetFilters( 'init', 'wp_cron' ) ) wp_cron(); exit(); }, -999999 );
	return( true );
}

function GetContentProcessorForce( $sett )
{
	if( !(isset($sett[ 'debug' ])?$sett[ 'debug' ]:null) || !isset( $_REQUEST[ 'seraph_accel_proc' ] ) )
		return( null );
	return( !!$_REQUEST[ 'seraph_accel_proc' ] );
}

function ApplyContentProcessorForceSett( &$sett )
{
	$settContPrOverride = Gen::SanitizeTextData( $_REQUEST[ 'seraph_accel_proc' ] );
	if( !$settContPrOverride )
		return;

	if( $settContPrOverride === 'LRNSTR' )
	{
		$sett[ 'contPr' ] = array( 'enable' => true, 'grps' => Gen::GetArrField( $sett, array( 'contPr', 'grps' ), array() ) );
		return;
	}

	if( $settContPrOverride === '1' )
		return;

	$settContPrOverride = @json_decode( @base64_decode( $settContPrOverride ), true );
	if( is_array( $settContPrOverride ) )
	{
		$settContPrOverride[ 'enable' ] = true;
		$sett[ 'contPr' ] = $settContPrOverride;
	}
}

function GetCacheSessionSrvState( $dirSesss )
{
	$ctx = array( 'tmLast' => 0, 'stateId' => '' );

	Gen::DirEnum( $dirSesss . '/st_s', $ctx,
		function( $path, $file, &$ctx )
		{
			if( @filemtime( $path . '/' . $file ) > $ctx[ 'tmLast' ] )
				$ctx[ 'stateId' ] = $file;
		}
	);

	return( $ctx[ 'stateId' ] );
}

function SetCacheSessionSrvState( $dirSesss, $stateId )
{
	$dirSesss = $dirSesss . '/st_s';

	$hr = Gen::MakeDir( $dirSesss );
	if( Gen::HrFail( $hr ) )
		return( $hr );

	@touch( $dirSesss . '/' . $stateId );

	$ctx = array( 'stateId' => $stateId );

	if( !Gen::DirEnum( $dirSesss, $ctx,
		function( $path, $file, &$ctx )
		{
			if( $file != $ctx[ 'stateId' ] )
				@unlink( $path . '/' . $file );
		}
	) )
	{
		return( Gen::E_FAIL );
	}

	return( Gen::S_OK );
}

const TOF_COMPR_MAX	= 9;

function Tof_GetFileData( $dir, $id, $ver = null, $compressed = false, $oiCi = null )
{
	if( $oiCi !== null )
		$id = $oiCi . '.' . $id;

	$data = @file_get_contents( $dir . '/' . $id );
	if( $compressed )
		$data = @gzdecode( $data );
	$data = @unserialize( $data );

	if( !is_array( $data ) || ( $ver && $ver !== (isset($data[ 'v' ])?$data[ 'v' ]:null) ) )
		$data = array();

	return( $data );
}

function Tof_SetFileData( $dir, $id, $data, $ver = null, $tmp = false, $compressed = false, &$oiCi = null )
{
	$hr = Gen::MakeDir( $dir, true );
	if( Gen::HrFail( $hr ) )
		return( $hr );

	if( $ver )
		$data[ 'v' ] = $ver;

	$data = @serialize( $data );

	if( $oiCi !== null )
	{
		$oiCi = @md5( $data ) . '.' . sprintf( '%x', strlen( $data ) );
		$id = $oiCi . '.' . $id;

		if( @file_exists( $dir . '/' . $id ) )
			return( Gen::S_FALSE );
	}

	$fileTmp = tempnam( $dir, '' );
	if( !$fileTmp )
		return( Gen::E_FAIL );

	if( $compressed !== false )
		$data = @gzencode( $data, is_int( $compressed ) ? $compressed : -1 );

	if( @file_put_contents( $fileTmp, $data ) === false )
	{
		@unlink( $fileTmp );
		return( Gen::E_FAIL );
	}

	if( !@rename( $fileTmp, $tmp ? ( $fileTmp . '.' . $id ) : ( $dir . '/' . $id ) ) )
	{
		@unlink( $fileTmp );
		return( Gen::E_FAIL );
	}

	return( Gen::S_OK );
}

function GetCacheSiteIdAdjustPath( $sites, &$addr, &$siteSubId, &$path )
{
	if( !is_array( $sites ) )
		return( null );

	if( $path )
		$addr .= '/' . $path;

	$addrSite = $addr;
	for( ;; )
	{
		$id = (isset($sites[ $addrSite ])?$sites[ $addrSite ]:null);
		if( $id )
		{
			$path = ltrim( substr( $addr, strlen( $addrSite ) ), '/' );

			$posSubSite = strpos( $id, '-' );
			if( $posSubSite !== false )
			{
				$siteSubId = substr( $id, $posSubSite + 1 );
				$id = substr( $id, 0, $posSubSite );
			}

			$addr = $addrSite;
			return( $id );
		}

		$addrSiteNext = dirname( $addrSite );
		if( $addrSiteNext === $addrSite )
			break;
		$addrSite = $addrSiteNext;
		unset( $addrSiteNext );
	}

	return( null );
}

function CachePathNormalize( $path, &$pathIsDir )
{
	$path = strtolower( ltrim( $path, '/' ) );
	if( substr( $path, -1 ) == '/' )
	{
		$pathIsDir = true;
		$path = rtrim( $path, '/' );
	}

	return( $path );
}

function ParseContCachePathArgs( $serverArgs, &$args )
{
	$path = (isset($serverArgs[ 'REQUEST_URI' ])?$serverArgs[ 'REQUEST_URI' ]:null);
	$posQuery = strpos( $path, '?' );

	if( $posQuery !== false )
	{
		$queryOrig = substr( $path, $posQuery + 1 );
		if( $queryOrig != (isset($serverArgs[ 'QUERY_STRING' ])?$serverArgs[ 'QUERY_STRING' ]:null) )
		{
			$args = array();
			@parse_str( $queryOrig, $args );
		}

		$path = substr( $path, 0, $posQuery );
	}
	else
		$args = array();

	return( $path );
}

function GetContCacheEarlySkipData( &$path, &$pathIsDir, &$args )
{
	global $seraph_accel_g_cacheSkipData;

	if( $seraph_accel_g_cacheSkipData !== null )
		return( $seraph_accel_g_cacheSkipData );

	$seraph_accel_g_cacheSkipData = false;

	if( defined( 'SID' ) && SID != '' )
		$seraph_accel_g_cacheSkipData = array( 'skipped', array( 'reason' => 'sid' ) );
	else if( is_admin() )
		$seraph_accel_g_cacheSkipData = array( 'skipped', array( 'reason' => 'admin' ) );
	else if( defined( 'DOING_CRON' ) || isset( $_REQUEST[ 'doing_wp_cron' ] ) )
		$seraph_accel_g_cacheSkipData = array( 'skipped', array( 'reason' => 'cron' ) );
	else if( defined( 'XMLRPC_REQUEST' ) )
		$seraph_accel_g_cacheSkipData = array( 'skipped', array( 'reason' => 'xmlrpc' ) );
	else
	{
		$path = CachePathNormalize( ParseContCachePathArgs( $_SERVER, $args ), $pathIsDir );

		if( strpos( $path, 'robots.txt' ) !== false )
			$seraph_accel_g_cacheSkipData = array( 'skipped', array( 'reason' => 'robots' ) );
		else if( strpos( $path, '.htaccess' ) !== false )
			$seraph_accel_g_cacheSkipData = array( 'skipped', array( 'reason' => 'htaccess' ) );
		else if( strpos( '/' . $path, '/wp-' ) !== false )
			$seraph_accel_g_cacheSkipData = array( 'skipped', array( 'reason' => 'wpUrl' ) );
	}

	return( $seraph_accel_g_cacheSkipData );
}

function _NormalizeExclPath( &$path )
{
	if( strlen( $path ) > 1 && $path[ 0 ] === '/' )
		$path = substr( $path, 1 );
}

function IsUriByPartsExcluded( $settCache, $path, $args )
{
	if( is_string( $args ) )
		$args = Net::UrlParseQuery( $args );

	_NormalizeExclPath( $path );
	return( !!_ContProcGetExclStatus( $settCache, Gen::GetArrField( $settCache, array( 'ctxGrps' ), array() ), null, null, $path, $args ) );
}

function CheckPathInUriList( $a, $path )
{
	foreach( $a as $e )
	{
		_NormalizeExclPath( $e );

		if( IsStrRegExp( $e ) ? preg_match( $e, $path ) : ( strpos( $path, $e ) === 0 ) )
			return( $e );
	}

	return( null );
}

function _ContProcGetExclStatus( $settCache, $ctxGrps, $userAgent, $cookies, $path, &$args, $adjustArgs = false )
{

	if( !empty( $args ) )
	{
		if( Gen::GetArrField( $settCache, array( 'exclArgsAll' ), true ) )
			return( 'exclArgsAll' );

		if( Gen::GetArrField( $settCache, array( 'skipArgsAll' ), false ) )
			$args = array();

		$exclArgs = Gen::GetArrField( $settCache, array( 'exclArgs' ), array() );
		$skipArgs = Gen::GetArrField( $settCache, array( 'skipArgs' ), array() );
		foreach( $args as $argKey => $argVal )
		{
			$argKeyCmp = strtolower( $argKey );

			foreach( $exclArgs as $a )
				if( strpos( $argKeyCmp, $a ) === 0 )
					return( 'exclArgs:' . $a );

			foreach( $ctxGrps as $ctxGrp )
			{
				if( !(isset($ctxGrp[ 'enable' ])?$ctxGrp[ 'enable' ]:null) )
					continue;

				$ctxArgs = Gen::GetArrField( $ctxGrp, array( 'args' ), array() );
				foreach( $ctxArgs as $a )
					if( strpos( $argKeyCmp, $a ) === 0 )
						return( 'userCtxArgs:' . $a );
			}

			if( $adjustArgs )
				foreach( $skipArgs as $a )
					if( strpos( $argKeyCmp, $a ) === 0 )
						unset( $args[ $argKey ] );
		}
	}

	if( $uriExcl = CheckPathInUriList( Gen::GetArrField( $settCache, array( 'urisExcl' ), array() ), $path ) )
		return( 'urisExcl:' . $uriExcl );

	if( $userAgent )
		foreach( Gen::GetArrField( $settCache, array( 'exclAgents' ), array() ) as $e )
			if( strpos( $userAgent, $e ) !== false )
				return( 'exclAgents:' . $e );

	$exclCookies = Gen::GetArrField( $settCache, array( 'exclCookies' ), array() );
	if( $exclCookies && $cookies )
		foreach( $cookies as $cookKey => $cookVal )
			foreach( $exclCookies as $e )
				if( strpos( $cookKey, $e ) === 0 )
					return( 'exclCookies:' . $e );

	return( false );
}

function ContProcGetExclStatus( $siteId, $settCache, $path, $pathIsDir, &$args, &$varsOut, $adjustArgs = true, $adjustStat = true )
{
	global $seraph_accel_g_contProcGetExclStatus;

	if( $seraph_accel_g_contProcGetExclStatus !== null )
		return( $seraph_accel_g_contProcGetExclStatus );

	$tmCur = Gen::GetCurRequestTime();

	$varsOut = array();

	$userAgent = strtolower( (isset($_SERVER[ 'HTTP_USER_AGENT' ])?$_SERVER[ 'HTTP_USER_AGENT' ]:null) );

	$varsOut[ 'tmCur' ] = $tmCur;
	$varsOut[ 'userAgent' ] = $userAgent;

	$ctxGrps = Gen::GetArrField( $settCache, array( 'ctxGrps' ), array() );

	if( $pathIsDir )
		$path .= '/';
	$seraph_accel_g_contProcGetExclStatus = _ContProcGetExclStatus( $settCache, $ctxGrps, $userAgent, $_COOKIE, $path, $args, $adjustArgs );
	if( $seraph_accel_g_contProcGetExclStatus )
		return( $seraph_accel_g_contProcGetExclStatus );

	$sessInfo = GetCacheCurUserSession( $siteId );

	$userId = (isset($sessInfo[ 'userId' ])?$sessInfo[ 'userId' ]:null);

	$varsOut[ 'sessInfo' ] = $sessInfo;
	$varsOut[ 'userId' ] = $userId;

	{
		$stateCookId = '';
		{
			foreach( $ctxGrps as $ctxGrp )
				if( (isset($ctxGrp[ 'enable' ])?$ctxGrp[ 'enable' ]:null) )
					AccomulateCookiesState( $stateCookId, $_COOKIE, Gen::GetArrField( $ctxGrp, array( 'cookies' ), array() ) );
		}

		if( ( $stateCookId || $userId )  )
		{
			$varsOut[ 'isUserCtx' ] = true;

				$seraph_accel_g_contProcGetExclStatus = 'userCtx';
		}

		$varsOut[ 'stateCookId' ] = $stateCookId;
	}

	$shouldCurUserSessionExist = ShouldCurUserSessionExist();
	if( ( !(isset($sessInfo[ 'sessId' ])?$sessInfo[ 'sessId' ]:null) && ( $shouldCurUserSessionExist || $stateCookId ) ) || ( $shouldCurUserSessionExist && !$userId ) )
		$seraph_accel_g_contProcGetExclStatus = 'noCacheSession';

	return( $seraph_accel_g_contProcGetExclStatus );
}

function IsStrRegExp( $s )
{
	return( strpos( '/~@;%`#', (isset($s[ 0 ])?$s[ 0 ]:null) ) !== false );
}

function ExprConditionsSet_Parse( $expr )
{
	$a = explode( ' & ', $expr );
	foreach( $a as &$e )
	{
		$e = trim( $e );

		if( ( $posVal = strpos( $e, ' != ' ) ) !== false )
			$e = array( 'expr' => trim( substr( $e, 0, $posVal ) ), 'op' => 'ne', 'v' => trim( substr( $e, $posVal + 4 ) ) );
		else if( ( $posVal = strpos( $e, ' = ' ) ) !== false )
			$e = array( 'expr' => trim( substr( $e, 0, $posVal ) ), 'op' => 'e', 'v' => trim( substr( $e, $posVal + 3 ) ) );
		else if( Gen::StrStartsWith( $e, '!' ) )
			$e = array( 'expr' => trim( substr( $e, 1 ) ), 'op' => 'v' );
		else
			$e = array( 'expr' => $e, 'op' => '' );
	}

	return( $a );
}

function ExprConditionsSet_ItemOp( $e, $v )
{
	switch( $e[ 'op' ] )
	{
	case 'ne':		return( $v !== $e[ 'v' ] );
	case 'e':		return( $v === $e[ 'v' ] );
	case 'v':		return( !strlen( $v ) );
	}

	return( !!strlen( $v ) );
}

function ExprConditionsSet_IsItemOpFullSearch( $e )
{
	switch( $e[ 'op' ] )
	{
	case 'ne':
	case 'e':		return( true );
	}

	return( false );
}

function AccomulateCookiesState( &$state, $cookies, $elems )
{
	foreach( $elems as $ee )
	{
		$statePart = '';
		foreach( ExprConditionsSet_Parse( $ee ) as $e )
		{
			$isRegExp = IsStrRegExp( $e[ 'expr' ] );

			$cookieVals = array();
			foreach( $cookies as $cookKey => $cookVal )
				if( $isRegExp ? @preg_match( $e[ 'expr' ], $cookKey ) : Gen::StrStartsWith( $cookKey, $e[ 'expr' ] ) )
					$cookieVals[] = $cookVal;
			if( !$cookieVals )
				$cookieVals = array( '' );

			$found = false;
			foreach( $cookieVals as $cookVal )
			{
				if( ExprConditionsSet_ItemOp( $e, $cookVal ) )
				{
					$statePart .= $cookVal;
					$found = true;
				}
			}

			if( !$found )
			{
				$statePart = '';
				break;
			}
		}

		$state .= $statePart;
	}
}

function ContProcGetSkipStatus( $content )
{
	global $seraph_accel_g_contProcGetSkipStatus;

	if( $seraph_accel_g_contProcGetSkipStatus !== null )
		return( $seraph_accel_g_contProcGetSkipStatus );

	if( defined( 'REST_REQUEST' ) && REST_REQUEST )
		return( $seraph_accel_g_contProcGetSkipStatus = 'restapi' );

	if( defined( 'XMLRPC_REQUEST' ) && XMLRPC_REQUEST )
		return( $seraph_accel_g_contProcGetSkipStatus = 'xmlrpc' );

	if( is_404() )
		return( $seraph_accel_g_contProcGetSkipStatus = '404' );

	$errLast = error_get_last();
	if( Gen::GetArrField( $errLast, array( 'type' ), 0 ) & ( E_ERROR | E_PARSE | E_CORE_ERROR | E_COMPILE_ERROR | E_USER_ERROR | E_RECOVERABLE_ERROR ) )
		return( $seraph_accel_g_contProcGetSkipStatus = 'err:php:' . rawurlencode( $errLast[ 'message' ] ) );

	$http_response_code = http_response_code();
	if( $http_response_code !== 200 )
		return( $seraph_accel_g_contProcGetSkipStatus = 'httpCode:' . $http_response_code );

	if( is_search() )
		return( $seraph_accel_g_contProcGetSkipStatus = 'search' );
	if( is_feed() )
		return( $seraph_accel_g_contProcGetSkipStatus = 'feed' );

	if( Gen::StrPosArr( $content, array( '</body>', '</BODY>' ) ) === false && Gen::StrPosArr( $content, array( '</head>', '</HEAD>' ) ) === false )
		return( $seraph_accel_g_contProcGetSkipStatus = 'noHdrOrBody' );

	return( $seraph_accel_g_contProcGetSkipStatus = false );
}

function ContProcIsCompatView( $userAgent  )
{
	global $seraph_accel_g_contProcCompatView;

	if( $seraph_accel_g_contProcCompatView !== null )
		return( $seraph_accel_g_contProcCompatView );

	$compatView = false;

	return( $seraph_accel_g_contProcCompatView = $compatView );
}

function CorrectRequestScheme( &$serverArgs, $target = null )
{

	if( strtolower( (isset($serverArgs[ 'HTTPS' ])?$serverArgs[ 'HTTPS' ]:null) ) == 'on' || ( $target == 'client' && strtolower( (isset($serverArgs[ 'HTTP_X_FORWARDED_PROTO' ])?$serverArgs[ 'HTTP_X_FORWARDED_PROTO' ]:null) ) == 'https' ) )
	{
		if( (isset($serverArgs[ 'REQUEST_SCHEME' ])?$serverArgs[ 'REQUEST_SCHEME' ]:null) == 'http' && (isset($serverArgs[ 'SERVER_PORT' ])?$serverArgs[ 'SERVER_PORT' ]:null) == 80 )
			$serverArgs[ 'SERVER_PORT' ] = 443;
		$serverArgs[ 'REQUEST_SCHEME' ] = 'https';
	}
	else if( !(isset($serverArgs[ 'REQUEST_SCHEME' ])?$serverArgs[ 'REQUEST_SCHEME' ]:null) )
		$serverArgs[ 'REQUEST_SCHEME' ] = 'http';
}

function GetRequestHost( $serverArgs )
{
	return( strtolower( Net::GetRequestHost( $serverArgs ) ) );
}

function GetCurRequestUrl()
{
	$serverArgsTmp = Gen::ArrCopy( $_SERVER ); CorrectRequestScheme( $serverArgsTmp, 'client' );
	return( $serverArgsTmp[ 'REQUEST_SCHEME' ] . '://' . GetRequestHost( $serverArgsTmp ) . $serverArgsTmp[ 'REQUEST_URI' ] );
}

function _ShouldProcessItemsNext( $remove = false )
{
	$tmRuns = Gen::GetArrfield( get_option( 'seraph_accel_queueProcessItemsNext' ), array( '' ), array() );

	$run = false;
	$tmCur = Gen::GetCurRequestTime();
	for( $i = 0; $i < count( $tmRuns ); $i++ )
	{
		if( $tmCur < $tmRuns[ $i ] )
			continue;

		$run = true;
		if( !$remove )
			break;

		array_splice( $tmRuns, $i--, 1 );
	}

	if( !$run )
		return( false );

	if( $remove )
		update_option( 'seraph_accel_queueProcessItemsNext', $tmRuns, false );
	return( true );
}

add_filter( 'pre_get_ready_cron_jobs',
	function( $pre )
	{
		if( defined( 'DOING_CRON' ) )
		{

			if( _ShouldProcessItemsNext( true ) )
				_QueueProcessItems();
		}

		return( $pre );
	}
, 0, 1 );

add_action( 'seraph_accel_queueProcessItemsPeriodically',
	function()
	{

		_QueueProcessItems( true );
	}
);

function _QueueProcessItems( $per = false )
{
	if( is_multisite() ) switch_to_blog( BLOG_ID_CURRENT_SITE );
	$settCacheGlobal = Gen::GetArrField( Plugin::SettGet(), array( 'cache' ), array() );
	if( is_multisite() ) restore_current_blog();

	$nMaxItems = (isset($settCacheGlobal[ 'maxProc' ])?$settCacheGlobal[ 'maxProc' ]:null);
	if( !$nMaxItems )
		$nMaxItems = 1;
	$nMaxItemsTotal = $nMaxItems;

	$tmCur = microtime( true );

	foreach( glob( GetCacheDir() . '/qt/*.dat' ) as $fileTempQueue )
	{
		$data = @unserialize( @file_get_contents( $fileTempQueue ) );
		@unlink( $fileTempQueue );

		if( $data )
			CachePostPreparePageEx( Gen::GetArrField( $data, array( 'u' ), '' ), Gen::GetArrField( $data, array( 's' ), '' ), Gen::GetArrField( $data, array( 'p' ), 10 ), Gen::GetArrField( $data, array( 'h' ), array() ), Gen::GetArrField( $data, array( 't' ), 0.0 ) );
	}

	$aCurItemsPrior = array();
	{
		$dbtran = new Lock( 'ql', GetCacheDir() );
		if( !$dbtran -> Acquire() )
			return;

		$items = DbTbl::GetRows( Db::GetTblPrefix( 'seraph_accel_queue' ), null, $nMaxItems, array( 'state' => 1 ) );
		foreach( $items as $item )
		{
			$tmDur = $tmCur - $item[ 'tm' ];
			if( $tmDur <= 570 + 30 )
			{
				$nMaxItems --;
				$aCurItemsPrior[ (isset($item[ 'prior' ])?$item[ 'prior' ]:null) ] = true;
			}
			else
			{
				$data = Gen::GetArrField( Gen::Unserialize( (isset($item[ 'data' ])?$item[ 'data' ]:null) ), array( '' ), array() );
				$data[ 'p' ] = ( int )$item[ 'prior' ];
				$data[ 'td' ] = $tmDur;
				$data[ 'hr' ] = Gen::E_TIMEOUT;
				DbTbl::UpdateRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array( 'state' => 2, 'tm' => $tmCur, 'prior' => -1000, 'data' => Gen::Serialize( $data ) ), array( 'id' => $item[ 'id' ], 'state' => 1 ) );
			}
		}

		unset( $dbtran );
	}

	if( $per )
	{
		$dbtran = new Lock( 'ql', GetCacheDir() );
		if( !$dbtran -> Acquire() )
			return;

		$items = DbTbl::GetRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array( 'id' ), null, array( 'state' => 2 ), array( 'tm' => 'DESC' ) );
		for( $i = 10; $i < count( $items ); $i++ )
			DbTbl::DeleteRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array( 'id' => $items[ $i ][ 'id' ], 'state' => 2 ) );

		unset( $dbtran );
	}

	if( !$nMaxItems )
	{

		return;
	}

	$procInterval = (isset($settCacheGlobal[ 'procInterval' ])?$settCacheGlobal[ 'procInterval' ]:null);
	if( $procInterval )
	{
		if( $nMaxItems < $nMaxItemsTotal )
			return;

		$procEndLastTime = intval( get_option( 'seraph_accel_procEndLastTime' ) );
		if( $tmCur - $procEndLastTime < $procInterval )
			return;
	}

	$items = DbTbl::GetRows( Db::GetTblPrefix( 'seraph_accel_queue' ), null, $nMaxItems, array( 'state' => 0 ), array( 'prior' => 'ASC', 'tm' => 'ASC' ) );
	if( !$items )
	{

		return;
	}

	foreach( $items as $item )
	{
		$id = (isset($item[ 'id' ])?$item[ 'id' ]:null);
		$prior = (isset($item[ 'prior' ])?$item[ 'prior' ]:null);

		if( isset( $aCurItemsPrior[ -480 ] ) && $prior > -480 )
		    continue;

		$aCurItemsPrior[ $prior ] = true;

		Plugin::AsyncTaskPost( 'CacheProcessItem', array( 'id' => $id ) );

	}

}

function CacheInitQueueProcessor()
{
	$time = time() + ( 30 );
	$time -= $time % ( 30 );
	wp_schedule_single_event( $time, 'seraph_accel_queueProcessItemsPeriodically' );

	if( _ShouldProcessItemsNext() )
		wp_schedule_single_event( time(), 'seraph_accel_queueProcessItemsNextPulse' );

}

function CachePushQueueProcessor( $next = false, $immediately = false )
{

	$procInterval = 0;
	if( $next && $immediately === false )
	{
		if( is_multisite() ) switch_to_blog( BLOG_ID_CURRENT_SITE );
		$settCacheGlobal = Gen::GetArrField( Plugin::SettGet(), array( 'cache' ), array() );
		if( is_multisite() ) restore_current_blog();

		$procInterval = (isset($settCacheGlobal[ 'procInterval' ])?$settCacheGlobal[ 'procInterval' ]:null);
	}

	$time = time() + $procInterval;

	$tmRuns = Gen::GetArrfield( get_option( 'seraph_accel_queueProcessItemsNext' ), array( '' ), array() );

	if( gettype( $immediately ) !== 'boolean' )
	{
		$timeLast = get_option( 'seraph_accel_queueProcessItemNext' );
		if( $timeLast && ( $time - $timeLast < $immediately ) )
			$procInterval = 99999;
	}
	else if( $next && $immediately )
		update_option( 'seraph_accel_procEndLastTime', 0, false );

	$tmRuns[] = $time;
	update_option( 'seraph_accel_queueProcessItemsNext', $tmRuns, false );
	update_option( 'seraph_accel_queueProcessItemNext', $time, false );

	if( !$next && !IsCronEnabled() )
		return;

	if( $procInterval <= 5 )
	{
		if( $procInterval )
			sleep( $procInterval );

			wp_remote_get( add_query_arg( array( '_' => Gen::MicroTimeStamp() ), Wp::GetSiteWpRootUrl( 'wp-cron.php' ) ), array( 'timeout' => 5, 'sslverify' => apply_filters( 'https_local_ssl_verify', false ) ) );
	}

}

function ContentProcess_IsAborted()
{
	global $seraph_accel_g_prepPrms;

	if( $seraph_accel_g_prepPrms === null )
		return( false );

	$fileCtl = (isset($seraph_accel_g_prepPrms[ 'pc' ])?$seraph_accel_g_prepPrms[ 'pc' ]:null);
	if( !$fileCtl )
		return( false );

	return( !@file_exists( $fileCtl ) );
}

function _Process_GetCtlData( $fileCtl )
{
	return( @json_decode( Gen::FileGetContentExclusive( $fileCtl, '', true ), true ) );
}

function OnAsyncTask_CacheProcessItem( $args )
{

	$id = Gen::SanitizeId( (isset($args[ 'id' ])?$args[ 'id' ]:null) );
	if( !$id )
		return;

	$item = DbTbl::GetRows( Db::GetTblPrefix( 'seraph_accel_queue' ), null, 1, array( 'id' => $id ) );
	if( !$item )
		return;

	$item = $item[ 0 ];

	$data = Gen::GetArrField( Gen::Unserialize( (isset($item[ 'data' ])?$item[ 'data' ]:null) ), array( '' ), array() );
	if( !$data )
		return;

	@set_time_limit( 570 + 30 );

	$fileCtl = GetCacheDir() . '/pc';
	Gen::MakeDir( $fileCtl, true );
	if( $fileCtl = tempnam( $fileCtl, '' ) )
	{
		if( @rename( $fileCtl, $fileCtl . '.json' ) )
		{
			$fileCtl .= '.json';
			$data[ 'pc' ] = Gen::GetFileName( $fileCtl );
		}
		else
		{
			@unlink( $fileCtl );
			$fileCtl = null;
		}
	}

	$tmBegin = microtime( true );

	{
		$dbtran = new Lock( 'ql', GetCacheDir() );
		if( !$dbtran -> Acquire() )
			return;

		if( !DbTbl::UpdateRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array( 'state' => 1, 'tm' => $tmBegin, 'data' => Gen::Serialize( $data ) ), array( 'id' => $id, 'state' => 0 ) ) )
		{
			@unlink( $fileCtl );
			return;
		}

		unset( $dbtran );
	}

	$prepArgs = array( 'nonce' => hash_hmac( 'md5', '' . $tmBegin, NONCE_SALT ), 'pc' => (isset($data[ 'pc' ])?$data[ 'pc' ]:null), '_tm' => '' . $tmBegin );
	if( (isset($item[ 'prior' ])?$item[ 'prior' ]:null) == -480 )
		$prepArgs[ 'lrn' ] = (isset($data[ 'l' ])?$data[ 'l' ]:null);

	$url = add_query_arg( array( 'seraph_accel_prep' => @rawurlencode( @base64_encode( @json_encode( $prepArgs ) ) ) ), (isset($data[ 'u' ])?$data[ 'u' ]:null) );

	$hdrs = (isset($data[ 'h' ])?$data[ 'h' ]:null);
	if( !is_array( $hdrs ) )
		$hdrs = array();

	{
		$hdrsForRequest = $hdrs;
		$proto; Net::GetUrlWithoutProtoEx( $url, $proto );
		if( strtolower( $proto ) == 'https' )
		{
			Net::RemoveHeader( $hdrsForRequest, 'Upgrade-Insecure-Requests' );
			Net::RemoveHeader( $hdrsForRequest, 'Ssl' );

		}

		Net::RemoveHeader( $hdrsForRequest, 'Accept-Encoding' );

		unset( $proto );

		$requestRes = Wp::RemoteGet( $url, array( 'redirection' => 0, 'timeout' => 570, 'sslverify' => false, 'headers' => $hdrsForRequest ) );

		$tmFinish = microtime( true );
		$hr = Net::GetHrFromWpRemoteGet( $requestRes, true );

		$skipStatus = null;
		$httpCode = Net::GetResponseCodeFromHr( $hr );

		unset( $hdrsForRequest );
	}

	$needRepeat = false;
	$needLrn = false;
	$repeatIdx = null;

	if( $fileCtl )
	{

		$waitInstead = false;
		$ctlRes = _Process_GetCtlData( $fileCtl );
		if( Gen::GetArrField( $ctlRes, array( 'started' ) ) )
		{
			if( $hr == Net::E_TIMEOUT || $httpCode == 524 || $httpCode == 522 || $httpCode == 504 || $httpCode == 503 )
				$waitInstead = true;
			else if( $httpCode == 500 && strpos( wp_remote_retrieve_body( $requestRes ), '<h2>Request Timeout</h2>' ) !== false )
				$waitInstead = true;
			$skipStatus = (isset($ctlRes[ 'skipped' ])?$ctlRes[ 'skipped' ]:null);
		}
		else if( $httpCode && $httpCode != 500 )
		{
			if( $httpCode == 524 || $httpCode == 522 || $httpCode == 504 || $httpCode == 503 )
				if( ( $repeatIdx = (isset($data[ 'rdr' ])?$data[ 'rdr' ]:0) ) <= 3 )
					$needRepeat = true;
			$hr = Gen::HrSuccFromFail( $hr );
		}

		if( $waitInstead )
		{
			for( ;; )
			{
				sleep( 1 );

				$tmFinish = microtime( true );
				if( $tmFinish - $tmBegin > 570 )
				{
					$hr = Net::E_TIMEOUT;
					$requestRes = null;
					break;
				}

				if( !@file_exists( $fileCtl ) )
				{
					$hr = Gen::E_ABORTED;
					$requestRes = null;
					break;
				}

				$ctlRes = _Process_GetCtlData( $fileCtl );
				if( $ctlRes !== null && (isset($ctlRes[ 'finished' ])?$ctlRes[ 'finished' ]:null) )
				{
					$skipStatus = (isset($ctlRes[ 'skipped' ])?$ctlRes[ 'skipped' ]:null);
					$hr = $skipStatus ? ( Gen::StrStartsWith( $skipStatus, 'err:' ) ? Gen::E_FAIL : Gen::S_FALSE ) : Gen::S_OK;
					$requestRes = null;
					break;
				}
			}
		}
		else
		{
			if( !@file_exists( $fileCtl ) )
			{
				$hr = Gen::E_ABORTED;
				$requestRes = null;
			}
		}

		@unlink( $fileCtl );
	}

	$immediatelyPushQueue = false;
	if( $urlRedir = trim( wp_remote_retrieve_header( $requestRes, 'location' ) ) )
	{
		$urlRedir = remove_query_arg( array( 'seraph_accel_prep' ), $urlRedir );
		if( strpos( $urlRedir, '://' ) === false )
			$urlRedir = Net::GetSiteAddrFromUrl( $url, true ) . $urlRedir;

		if( (isset($item[ 'prior' ])?$item[ 'prior' ]:null) !== 10 )
			if( ( $redirIdx = (isset($data[ 'rdr' ])?$data[ 'rdr' ]:0) ) <= 4 )
				if( CachePostPreparePageEx( $urlRedir, $item[ 'site_id' ], ( int )$item[ 'prior' ], $hdrs, $item[ 'tm' ], $redirIdx + 1, (isset($data[ 'l' ])?$data[ 'l' ]:null) ) )
					$immediatelyPushQueue = true;
	}

	$data[ 'td' ] = $tmFinish - $tmBegin;
	$data[ 'p' ] = ( int )$item[ 'prior' ];

	if( $hr != Gen::S_OK )
	{
		$data[ 'hr' ] = $hr;
		if( is_wp_error( $requestRes ) )
			$data[ 'r' ] = $requestRes -> get_error_message();
		if( $skipStatus )
			$data[ 'r' ] = $skipStatus;
	}
	else
	{
		if( !$skipStatus )
			$skipStatus = trim( wp_remote_retrieve_header( $requestRes, 'X-seraph-accel-prepskip' ) );
		if( $skipStatus )
		{
			$data[ 'hr' ] = Gen::StrStartsWith( $skipStatus, 'err:' ) ? Gen::E_FAIL : Gen::S_FALSE;
			$data[ 'r' ] = $skipStatus;

			if( $skipStatus == 'alreadyProcessing' || $skipStatus == 'lrnNeed' )
				$needRepeat = true;
			else if( Gen::StrStartsWith( $skipStatus, 'lrnNeed:' ) )
				$needLrn = substr( $skipStatus, 8 );
		}
	}

	if( $needLrn )
	{
		{
			$dbtran = new Lock( 'ql', GetCacheDir() );
			if( !$dbtran -> Acquire() )
				return;

			DbTbl::DeleteRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array( 'id' => $id ) );

			unset( $dbtran );
		}

		CachePostPreparePageEx( (isset($data[ 'u' ])?$data[ 'u' ]:null), $item[ 'site_id' ], -480, $hdrs, $item[ 'tm' ], null, $needLrn );
		$immediatelyPushQueue = true;
	}
	else
	{
		if( isset( $data[ 'hr' ] ) && $data[ 'hr' ] != Gen::S_OK && $urlRedir && $urlRedir == (isset($data[ 'u' ])?$data[ 'u' ]:null) )
		{
			$data[ 'hr' ] = Gen::E_FAIL;
			$data[ 'r' ] = 'redirectToItself';
		}

		{
			$dbtran = new Lock( 'ql', GetCacheDir() );
			if( !$dbtran -> Acquire() )
				return;

			{
				$dataExtUpdated = DbTbl::GetRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array( 'data' ), 1, array( 'id' => $id, 'state' => 1 ) );
				if( $dataExtUpdated )
				{
					if( $dataExtUpdated = Gen::GetArrField( Gen::Unserialize( (isset($dataExtUpdated[ 0 ][ 'data' ])?$dataExtUpdated[ 0 ][ 'data' ]:null) ), array( '' ), array() ) )
						if( (isset($dataExtUpdated[ 'rpt' ])?$dataExtUpdated[ 'rpt' ]:null) )
							$needRepeat = true;

					unset( $dataExtUpdated );
				}
			}

			DbTbl::UpdateRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array( 'state' => 2, 'tm' => $tmFinish, 'prior' => -1000, 'data' => Gen::Serialize( $data ) ), array( 'id' => $id, 'state' => 1 ) );

			unset( $dbtran );
		}
	}

	update_option( 'seraph_accel_procEndLastTime', ( int )$tmFinish, false );

	if( $needRepeat && CachePostPreparePageEx( (isset($data[ 'u' ])?$data[ 'u' ]:null), $item[ 'site_id' ], ( int )$item[ 'prior' ], $hdrs, $item[ 'tm' ], $repeatIdx !== null ? ( $repeatIdx + 1 ) : null, (isset($data[ 'l' ])?$data[ 'l' ]:null) ) )
	    $immediatelyPushQueue = true;

	CachePushQueueProcessor( true, $immediatelyPushQueue );

}

function CacheInitQueueTable( $force = false )
{
	$data = Plugin::DataGet();
	if( !$force && Gen::GetArrField( $data, 'queueDbVer', 0 ) == QUEUE_DB_VER )
		return;

	DbTbl::CreateUpdate( Db::GetTblPrefix( 'seraph_accel_queue' ), array(
		'id' => array( 'type' => 'CHAR(32)', 'attrs' => array( 'NOT NULL', 'PRIMARY KEY' ) ),
		'prior' => array( 'type' => 'INT', 'attrs' => array( 'INDEX' ) ),
		'state' => array( 'type' => 'INT', 'attrs' => array( 'INDEX' ) ),
		'tm' => array( 'type' => 'DOUBLE', 'attrs' => array( 'INDEX' ) ),
		'site_id' => array( 'type' => 'VARCHAR(100)', 'attrs' => array( 'INDEX' ) ),
		'data' => array( 'type' => 'TEXT' ),
	) );

	Gen::SetArrField( $data, 'queueDbVer', QUEUE_DB_VER );
	Plugin::DataSet( $data );
}

function GetViewDeviceGrpNameFromData( $viewsDeviceGrp )
{
	$viewName = (isset($viewsDeviceGrp[ 'name' ])?$viewsDeviceGrp[ 'name' ]:null);
	if( !$viewName )
		$viewName = 'id:' . (isset($viewsDeviceGrp[ 'id' ])?$viewsDeviceGrp[ 'id' ]:null);
	return( $viewName );
}

function _CachePostPreparePageEx_StopAndRepeat( $id, $data = null )
{
	$itemInProgressData = DbTbl::GetRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array( 'data' ), 1, array( 'id' => $id, 'state' => 1 ) );
	if( !$itemInProgressData )
		return;

	$itemInProgressData = Gen::GetArrField( Gen::Unserialize( (isset($itemInProgressData[ 0 ][ 'data' ])?$itemInProgressData[ 0 ][ 'data' ]:null) ), array( '' ), array() );

	if( (isset($itemInProgressData[ 'rpt' ])?$itemInProgressData[ 'rpt' ]:null) || !( $fileCtl = GetProcControlfileFullPath( (isset($itemInProgressData[ 'pc' ])?$itemInProgressData[ 'pc' ]:null) ) ) )
		return;

	@unlink( $fileCtl );

	if( $data )
		$itemInProgressData = array_merge( $data, $itemInProgressData );
	$itemInProgressData[ 'rpt' ] = true;
	DbTbl::UpdateRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array( 'data' => Gen::Serialize( $itemInProgressData ) ), array( 'id' => $id, 'state' => 1 ) );
}

function CachePostPreparePageEx( $url, $siteId, $priority, $headers = null, $time = null, $redirIdx = null, $lrnId = null )
{
	if( !$url )
		return( false );

	if( $priority == -480 && !$lrnId )
		return( false );

	$settCache = Gen::GetArrField( Plugin::SettGet(), array( 'cache' ), array() );

	if( $time === null )
		$time = microtime( true );

	if( !is_array( $headers ) )
		$headers = array();

	$id = $url . $priority;
	$idLearn = $url . -480;
	foreach( $headers as $header => $headerVal )
	{
		$headerVal = $header . ( is_array( $headerVal ) ? implode( '', $headerVal ) : $headerVal );
		$id .= $headerVal;
		$idLearn .= $headerVal;
	}
	$id = md5( $id );
	$idLearn = md5( $idLearn );

	$viewName = null;
	if( $viewsDeviceGrp = GetCacheViewDeviceGrp( $settCache, strtolower( (isset($headers[ 'User-Agent' ])?$headers[ 'User-Agent' ]:null) ) ) )
		$viewName = GetViewDeviceGrpNameFromData( $viewsDeviceGrp );

	if( $priority == 10 )
	{
		$count = DbTbl::GetRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array( 'id' ), null, null, null, ARRAY_A, array( 'count' => true ) );

		$count = DbTbl::GetCountFromRowsResult( $count );

		if( $count > 1000 )
		{

			return( null );
		}
	}

	$data = array( 'u' => $url, 'h' => $headers, 'v' => $viewName );
	if( $redirIdx )
		$data[ 'rdr' ] = $redirIdx;
	if( $lrnId )
		$data[ 'l' ] = $lrnId;

	{
		$dbtran = new Lock( 'ql', GetCacheDir() );
		if( !$dbtran -> Acquire() )
			return( false );

		DbTbl::DeleteRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array( 'id' => $id, 'state' => 2 ) );

		$res = !!DbTbl::InsertRow( Db::GetTblPrefix( 'seraph_accel_queue' ), array( 'id' => $id, 'state' => 0, 'prior' => $priority, 'tm' => $time, 'site_id' => $siteId, 'data' => Gen::Serialize( $data ) ) );
		if( !$res )
		{

			DbTbl::UpdateRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array( 'data' => Gen::Serialize( $data ) ), array( 'id' => $id, 'state' => 0 ) );

			if( $priority !== 10 )
			{

				_CachePostPreparePageEx_StopAndRepeat( $id, $data );
			}
		}

		if( $priority !== 10 )
			if( $id != $idLearn )
				_CachePostPreparePageEx_StopAndRepeat( $idLearn );

		unset( $dbtran );
	}

	return( $res );
}

function CachePrepareQueueDelete( $siteId )
{
	$dbtran = new Lock( 'ql', GetCacheDir() );
	if( !$dbtran -> Acquire() )
		return;

	DbTbl::DeleteRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array_merge( array( 'state' => 0 ), $siteId ? array( 'site_id' => $siteId ) : array() ) );
	DbTbl::DeleteRows( Db::GetTblPrefix( 'seraph_accel_queue' ), array_merge( array( 'state' => 2 ), $siteId ? array( 'site_id' => $siteId ) : array() ) );

	unset( $dbtran );
}

function GetExtContents( $url, &$contMimeType = null, $userAgentCmn = true, $timeout = 30, $rememberServerState = true )
{

	$args = array( 'sslverify' => true, 'timeout' => $timeout );
	if( $userAgentCmn )
		$args[ 'user-agent' ] = 'Mozilla/99999.9 AppleWebKit/9999999.99 (KHTML, like Gecko) Chrome/999999.0.9999.99 Safari/9999999.99 seraph-accel-Agent/2.16.3';

	global $seraph_accel_g_aGetExtContentsFailedSrvs;

	if( $serverId = Net::UrlParse( $url ) )
		$serverId = Net::UrlDeParse( $serverId, 0, array( PHP_URL_USER, PHP_URL_PASS, PHP_URL_PATH, PHP_URL_QUERY, PHP_URL_FRAGMENT ) );

	if( $rememberServerState && $serverId && Gen::HrFail( (isset($seraph_accel_g_aGetExtContentsFailedSrvs[ $serverId ])?$seraph_accel_g_aGetExtContentsFailedSrvs[ $serverId ]:null) ) )
		return( false );

	$res = Wp::RemoteGet( $url, $args );
	$hr = Net::GetHrFromWpRemoteGet( $res );
	if( Gen::HrFail( $hr ) )
	{

		if( $rememberServerState && ( $hr == Gen::E_TIMEOUT || $hr == Net::E_TIMEOUT ) && $serverId )
			$seraph_accel_g_aGetExtContentsFailedSrvs[ $serverId ] = $hr;
		return( false );
	}

	$contMimeType = wp_remote_retrieve_header( $res, 'Content-Type' );
	return( wp_remote_retrieve_body( $res ) );
}

function CacheExtractPreparePageParams( &$args )
{
	$prms = (isset($args[ 'seraph_accel_prep' ])?$args[ 'seraph_accel_prep' ]:null);
	if( !$prms )
		return( null );

	$requestUri = &$_SERVER[ 'REQUEST_URI' ];
	$requestUriArgs = Net::UrlExtractArgs( $requestUri );

	$redirect_query_string_args = Net::UrlParseQuery( $_SERVER[ 'REDIRECT_QUERY_STRING' ] );
	$query_string_args = Net::UrlParseQuery( $_SERVER[ 'QUERY_STRING' ] );

	unset( $args[ 'seraph_accel_prep' ] );
	unset( $_GET[ 'seraph_accel_prep' ] );
	unset( $_REQUEST[ 'seraph_accel_prep' ] );
	unset( $requestUriArgs[ 'seraph_accel_prep' ] );
	unset( $redirect_query_string_args[ 'seraph_accel_prep' ] );
	unset( $query_string_args[ 'seraph_accel_prep' ] );

	$requestUri = Net::UrlAddArgs( $requestUri, $requestUriArgs );

	$_SERVER[ 'REDIRECT_QUERY_STRING' ] = Net::UrlBuildQuery( $redirect_query_string_args );
	$_SERVER[ 'QUERY_STRING' ] = Net::UrlBuildQuery( $query_string_args );

	$prms = @json_decode( @base64_decode( Gen::SanitizeTextData( $prms ) ), true );
	if( hash_hmac( 'md5', '' . (isset($prms[ '_tm' ])?$prms[ '_tm' ]:null), NONCE_SALT ) != (isset($prms[ 'nonce' ])?$prms[ 'nonce' ]:null) )
		return( null );

	unset( $prms[ '_tm' ] );
	unset( $prms[ 'nonce' ] );

	if( isset( $prms[ 'pc' ] ) )
		$prms[ 'pc' ] = GetProcControlfileFullPath( $prms[ 'pc' ] );

	return( $prms );
}

function GetCacheViewDeviceGrp( $settCache, $userAgent )
{
	if( !(isset($settCache[ 'views' ])?$settCache[ 'views' ]:null) )
		return( null );

	$viewsDeviceGrps = Gen::GetArrField( $settCache, array( 'viewsDeviceGrps' ), array() );

	foreach( $viewsDeviceGrps as $viewsDeviceGrp )
	{
		if( !(isset($viewsDeviceGrp[ 'enable' ])?$viewsDeviceGrp[ 'enable' ]:null) )
			continue;

		$a = implode( ' ', Gen::GetArrField( $viewsDeviceGrp, array( 'agents' ), array() ) );
		if( $a && strpos( $userAgent, $a ) !== false )
			return( $viewsDeviceGrp );
	}

	foreach( $viewsDeviceGrps as $viewsDeviceGrp )
	{
		if( !(isset($viewsDeviceGrp[ 'enable' ])?$viewsDeviceGrp[ 'enable' ]:null) )
			continue;

		foreach( Gen::GetArrField( $viewsDeviceGrp, array( 'agents' ), array() ) as $a )
			if( strpos( $userAgent, $a ) !== false )
				return( $viewsDeviceGrp );
	}

	return( null );
}

function GetCurHdrsToStoreInCache( $settCache )
{
	$res = array();

	$hdrPatterns = (isset($settCache[ 'hdrs' ])?$settCache[ 'hdrs' ]:null);
	if( !$hdrPatterns )
		return( $res );

	foreach( headers_list() as $hdr )
	{
		foreach( $hdrPatterns as $hdrPattern )
		{
			if( @preg_match( $hdrPattern, $hdr ) )
			{
				$res[] = $hdr;
				break;
			}
		}
	}

	return( $res );
}

function LastErrDsc_Set( $txt )
{
	global $seraph_accel_g_lastErrDsc;
	$seraph_accel_g_lastErrDsc = $txt;
}

function LastErrDsc_Get()
{
	global $seraph_accel_g_lastErrDsc;
	return( $seraph_accel_g_lastErrDsc );
}

function _SetExpirableOption( $option, $value, $timeout )
{
	update_option( $option, $value, false );
	update_option( $option . '_tmMax', time() + $timeout, false );
}

function _DelExpirableOption( $option )
{
	delete_option( $option );
	delete_option( $option . '_tmMax' );
}

function _DelExpiredOption( $option )
{
	$tmMax = get_option( $option . '_tmMax' );
	if( $tmMax && $tmMax < time() )
		_DelExpirableOption( $option );
}

function LogWrite( $text, $severity = Ui::MsgInfo )
{
	Gen::LogWrite( GetCacheDir() . '/logs/log.txt', $text, $severity );
}

